var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var recepcion;
        (function (recepcion) {
            //Inicio de proceso de alta de asistente de recepción. PUEDE VENIR O NO SELECCIONADA UNA ORDEN DE RECEPCIÓN
            recepcion.comenzarNuevoAsistente = (btn, IdOrdenRecepcion, IdProveedor) => {
                if (!IdProveedor) {
                    flexygo.msg.warning("Selecciona un proveedor válido para continuar");
                    return;
                }
                let strdef = IdOrdenRecepcion ? `{"IdOrdenRecepcion" : ${IdOrdenRecepcion}, "IdProveedor" : "${IdProveedor}"}` : `{"IdProveedor" : "${IdProveedor}"}`;
                let where = `IdProveedor = '${IdProveedor}' AND IdOrdenRecepcion = ${IdOrdenRecepcion}`;
                flexygo.nav.openPageName('PDA_pg_Recepciones_PedidosProv_NuevoAsistente_Datos', null, where, strdef, 'current', true);
            };
            recepcion.initAltaAsistente = () => {
                //Comprobación para ocultar campos si tiene orden recepción
                let def = flexygo.pda.getDefaults(null);
                if (def.IdOrdenRecepcion) {
                    $("#contGenOR").addClass("hidden");
                    $("#contUbicLectura").addClass("hidden");
                }
            };
            recepcion.seleccionarAsistente = () => {
                if (!$("#IdAsistente").val()) {
                    flexygo.msg.warning("Selecciona un asistente");
                    return;
                }
                let def = flexygo.pda.getDefaults(null);
                def.IdAsistente = Number($("#IdAsistente").val());
                def.IdUbicacionOrigen = $("#IdUbicacion").val();
                flexygo.nav.openPageName('SGA_PDA_pg_Recepciones_PedidosPendientes', '', `IdAsistente = ${def.IdAsistente}`, JSON.stringify(def), 'current', false);
            };
            recepcion.nuevoAsistente = (btn) => {
                let def = flexygo.pda.getDefaults(null);
                //Parámetros proceso
                let IdUbicacion;
                let NumAlb = $("#numAlb").val();
                let FechaAlb = $("#fechaAlb").val();
                let GenerarOrdenRecep = $("#checkGeneraOR").prop("checked");
                let ActualizarAlbaranes = $("#checkActualizarAlbaranes").prop("checked");
                let IdOrdenRecepcion = def.IdOrdenRecepcion ? def.IdOrdenRecepcion : 0;
                let IdProveedor = def.IdProveedor;
                if (!NumAlb || !FechaAlb) {
                    flexygo.msg.warning("Introduce un número y una fecha de albarán");
                    return;
                }
                //Si no hemos seleccionado orden de recepcion se comprueba que la ubicación se haya seleccionado, si tenemos orden se coge de esta
                if (!IdOrdenRecepcion) {
                    if (!$("#CodUbic").val()) {
                        flexygo.msg.warning("Selecciona una ubicación");
                        return;
                    }
                    else {
                        IdUbicacion = $("#cboUbicaciones").val();
                    }
                }
                else {
                    let OrdenRecep = new flexygo.obj.Entity(`SGA_PDA_Orden_Recepcion`, `IdOrdenRecepcion = ${IdOrdenRecepcion}`);
                    OrdenRecep.read();
                    IdUbicacion = OrdenRecep.data.IdUbicacion.Value;
                }
                let proc = new flexygo.Process('SGA_PDA_dll_Asistente_Recepcion_Cabecera_Crear', null, null);
                let params = [
                    { 'Key': 'IdProveedor', 'Value': IdProveedor },
                    { 'Key': 'NumAlbProv', 'Value': NumAlb },
                    { 'Key': 'FechaAlb', 'Value': FechaAlb },
                    { 'Key': 'IdUbicacionRecepcion', 'Value': IdUbicacion },
                    { 'Key': 'GenerarOrdenRecep', 'Value': GenerarOrdenRecep },
                    { 'Key': 'Actualizar_Albaranes', 'Value': ActualizarAlbaranes },
                    { 'Key': 'IdOrdenRecepcion', 'Value': IdOrdenRecepcion }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.SuccessMessage) {
                            def.IdAsistente = response.Data.IdAsistente;
                            def.IdUbicacionOrigen = IdUbicacion;
                            flexygo.nav.openPageName('SGA_PDA_pg_Recepciones_PedidosPendientes', '', `IdAsistente = ${def.IdAsistente}`, JSON.stringify(def), 'current', false);
                        }
                    }
                });
            };
            recepcion.seleccionPedidoPendiente = (IdDocObjeto, Seleccionado, IdAsistente, Objeto, elem) => {
                // Marca o desmarca el pedido como seleccionado para asociarlo o no posteriormente a la recepción
                let proc = new flexygo.Process('SGA_PDA_dll_Asistente_Recepcion_Seleccion_Pedido', null, null);
                let params = [
                    { 'Key': 'IdDocObjeto', 'Value': IdDocObjeto },
                    { 'Key': 'Seleccionado', 'Value': !Seleccionado },
                    { 'Key': 'IdAsistente', 'Value': IdAsistente },
                    { 'Key': 'Objeto', 'Value': Objeto }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.SuccessMessage) {
                            flexygo.pda.refreshModule("SGA_PDA_m_Recepciones_PedidosProv_ListadoPedidosPendientes");
                        }
                    }
                });
            };
            recepcion.abrirPaginaLecturaArticulos = () => {
                let defaults = flexygo.pda.getDefaults(null);
                //Se rellena la descripción de las propiedades en la tabla temporal de propiedades para el asistente seleccionado
                let rellenarPropidades = flexygo.pda.recepcion.RellenarPropiedadesTemp(defaults.IdAsistente);
                rellenarPropidades.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                    }
                });
                flexygo.nav.openPageName('PDA_pg_Recepciones_LecturaArticulos', '', `IdAsistente = ${defaults.IdAsistente}`, JSON.stringify(flexygo.pda.getDefaults(null)), 'current', false);
            };
            recepcion.confirmarLectura = () => {
                let defaults = flexygo.pda.getDefaults(null);
                if (!$("#cboArticulos").val() || !$("#cantidad").val()) {
                    flexygo.msg.warning("Selecciona un artículo y una cantidad");
                    return;
                }
                //Buscamos si el artículo está pendiente de recibir y si no pedimos confirmación de lectura.
                let ArticuloEnt = new flexygo.obj.Entity(`SGA_PDA_Articulos`);
                let lista = ArticuloEnt.getView("SGA_PDA_v_ArticulosPendientes_AsistenteRecepcion", 0, 10000, `IdArticulo = '${$("#cboArticulos").val()}' AND IdAsistente = ${defaults.IdAsistente}`, "", null);
                if (lista.length == 0) {
                    flexygo.msg.confirm("El artículo leído no está pendiente de recibir, ¿Añadir igualmente?", function (ret) {
                        if (ret) {
                            flexygo.pda.recepcion.execConfirmarLectura();
                        }
                    });
                }
                else {
                    flexygo.pda.recepcion.execConfirmarLectura();
                }
            };
            recepcion.execConfirmarLectura = () => {
                let defaults = flexygo.pda.getDefaults(null);
                //Parámetros
                const IdAsistente = defaults.IdAsistente;
                const IdArticulo = $("#cboArticulos").val();
                const Cantidad = Number($("#cantidad").val());
                const NumLoteProv = $("#loteProv").val();
                const P1 = $("#cboP1").val();
                const P2 = $("#cboP2").val();
                //Guardado de lectura
                let proc = new flexygo.Process('SGA_PDA_dll_Asistente_Recepcion_Guardar_Lectura', null, null);
                let params = [
                    { 'Key': 'IdAsistente', 'Value': IdAsistente },
                    { 'Key': 'IdArticulo', 'Value': IdArticulo },
                    { 'Key': 'Cantidad', 'Value': Cantidad },
                    { 'Key': 'NumLoteProv', 'Value': NumLoteProv },
                    { 'Key': 'P1', 'Value': P1 },
                    { 'Key': 'P2', 'Value': P2 }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.SuccessMessage) {
                            let rellenarPropidades = flexygo.pda.recepcion.RellenarPropiedadesTemp(IdAsistente);
                            rellenarPropidades.catch(function (error) {
                                if (error && error != "") {
                                    flexygo.msg.warning(error);
                                }
                            });
                            flexygo.msg.success("Lectura guardada");
                            flexygo.nav.openPageName('PDA_pg_Recepciones_LecturaArticulos', '', `IdAsistente = ${defaults.IdAsistente}`, JSON.stringify(flexygo.pda.getDefaults(null)), 'current', false);
                        }
                    }
                });
            };
            recepcion.RellenarPropiedadesTemp = (IdAsistente) => {
                if (!IdAsistente) {
                    let defaults = flexygo.pda.getDefaults(null);
                    IdAsistente = Number(defaults.IdAsistente);
                }
                let promesa = new Promise(function (resolve, reject) {
                    let proc = new flexygo.Process('SGA_PDA_dll_RellenaTablaTemporalPropiedadesRecepciones', null, null);
                    let params = [{ 'Key': 'IdAsistente', 'Value': IdAsistente }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.SuccessMessage) {
                                return resolve();
                            }
                        }
                    });
                });
                return promesa;
            };
            recepcion.continuarConfirmarLectura = () => {
                let defaults = flexygo.pda.getDefaults(null);
                flexygo.nav.openPageName('PDA_pg_Recepciones_ResumenLecturas', '', `IdAsistente = ${defaults.IdAsistente}`, JSON.stringify(flexygo.pda.getDefaults(null)), 'current', false);
            };
            recepcion.eliminarLecturas = (todas) => {
                let msg = todas ? `Se eliminarán todas las líneas, ¿Continuar?` : "Se eliminarán la líneas seleccionadas, ¿Continuar?";
                flexygo.msg.confirm(msg, function (ret) {
                    if (ret) {
                        let defaults = flexygo.pda.getDefaults(null);
                        let proc = new flexygo.Process('SGA_PDA_dll_Recepciones_EliminarLecturas', null, null);
                        let params;
                        if (todas) {
                            params = [
                                { 'Key': 'IdAsistente', 'Value': defaults.IdAsistente },
                                { 'Key': 'IdLinea', 'Value': 0 },
                                { 'Key': 'IdDetalle', 'Value': 0 }
                            ];
                            proc.run(params, (response) => {
                                if (response) {
                                    if (response.SuccessMessage) {
                                        flexygo.msg.success("Lectura(s) eliminada(s)");
                                        flexygo.pda.refreshModule("SGA_PDA_m_Recepciones_ResumenLecturas_List");
                                    }
                                }
                            });
                        }
                        else {
                            if ($(".listDetailPDASelected").length == 0) {
                                flexygo.msg.warning("Selecciona una línea al menos para eliminar");
                                return;
                            }
                            for (var i = 0; i < $(".listDetailPDASelected").length; i++) {
                                let params = [
                                    { 'Key': 'IdAsistente', 'Value': defaults.IdAsistente },
                                    { 'Key': 'IdLinea', 'Value': Number($(".listDetailPDASelected")[i].getAttribute("IdLinea")) },
                                    { 'Key': 'IdDetalle', 'Value': $(".listDetailPDASelected")[i].getAttribute("IdDetalle") ? Number($(".listDetailPDASelected")[i].getAttribute("IdDetalle")) : 0 }
                                ];
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.SuccessMessage) {
                                            if (i == $(".listDetailPDASelected").length) {
                                                flexygo.pda.refreshModule("SGA_PDA_m_Recepciones_ResumenLecturas_List");
                                            }
                                        }
                                    }
                                });
                            }
                        }
                    }
                });
            };
            recepcion.generarAlbaran = (btn) => {
                flexygo.msg.confirm("Se generará el albarán con las lecturas seleccionadas, ¿Continuar?", function (ret) {
                    if (ret) {
                        flexygo.pda.addLock();
                        let defaults = flexygo.pda.getDefaults(null);
                        let proc = new flexygo.Process('SGA_PDA_dll_Asistente_Recepcion_Generar_Albaran', null, null);
                        let params = [
                            { 'Key': 'IdAsistente', 'Value': defaults.IdAsistente },
                        ];
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.SuccessMessage) {
                                    flexygo.msg.success("Albarán generado correctamente", null, null);
                                    flexygo.pda.removeLock();
                                    flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, btn);
                                }
                            }
                        });
                    }
                });
            };
            recepcion.eliminarAsistente = (btn) => {
                if (!$("#IdAsistente").val()) {
                    flexygo.msg.warning("Selecciona un asistente primero");
                    return;
                }
                flexygo.msg.confirm("Se eliminará el asistente de recepción, ¿Continuar?", function (ret) {
                    if (ret) {
                        let defaults = flexygo.pda.getDefaults(null);
                        let proc = new flexygo.Process('SGA_PDA_dll_Asistente_Recepcion_Eliminar_Asistente', null, null);
                        let params = [
                            { 'Key': 'IdAsistente', 'Value': Number($("#IdAsistente").val()) },
                        ];
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.SuccessMessage) {
                                    flexygo.pda.refreshModule("SGA_PDA_m_Recepciones_PedidosProv_ListadoAsistentes");
                                    flexygo.msg.success("Asistente eliminado correctamente");
                                }
                            }
                        });
                    }
                });
            };
            recepcion.initListadoAsistentes = (module) => {
                if (module.querySelector("flx-list").data.length == 0) {
                    flexygo.nav.openPageName('PDA_pg_Recepciones_PedidosProv_NuevoAsistente_Prov', '', '', '', 'current', true);
                }
            };
            //LEER ARTÍCULO Recepciones: lectura de artículo para incluir como detalle del movimiento
            recepcion.LeerArticulo = (item, modName, modType, event, saltarLecturaStock) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLote = $('#loteProv');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                let pbUnidadStock = $('flx-text[name = "pbUnidadStock"]');
                let pbStock = $('flx-text[name = "pbStock"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    let articulo = flexygo.pda.articulo.Buscar(valorBusqueda);
                    articulo.then(function (datos) {
                        //No encontrado
                        if (!datos.IdArticulo) {
                            flexygo.msg.warning("No se ha encontrado ningún artículo.");
                            flexygo.pda.generarbulto.LimpiarCampos();
                            return;
                        }
                        //Módulo con datos del artículo leído
                        let module = $('flx-module')[0];
                        let page = flexygo.history.get(module);
                        let modLectura = $(`[modulename=${modName}]${modType}`)[0];
                        modLectura.additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                        modLectura.init();
                        //Ocultamos o mostramos lote según artículo
                        if (!datos.RequiereLote) {
                            pbLote.hide();
                        }
                        else {
                            pbLote.show();
                        }
                        //TRATAMOS PROPIEDADES
                        //Ocultamos/Mostramos los combos y cargamos la propiedad recibida
                        datos.RequiereP1 ? pbComboP1.show() : pbComboP1.hide();
                        datos.RequiereP2 ? pbComboP2.show() : pbComboP2.hide();
                        if (datos.P1) {
                            pbComboP1.val(datos.P1);
                        }
                        ;
                        if (datos.P2) {
                            pbComboP2.val(datos.P2);
                        }
                        ;
                        //Valores de campos de búsqueda
                        if ((item.tagName).toLowerCase() == "flx-dbcombo") {
                            //Evento lanzado por el combo, se pone en el código el CodBarras asociado o IdArticulo si no tiene código
                            valorBusqueda = datos.IdArticulo;
                            pbCodigo.val(valorBusqueda);
                        }
                        else {
                            //Evento lanzado por el campo de texto, se establece el ID en el combo
                            pbCombo.val(datos.IdArticulo);
                        }
                        //Valor de búsqueda para no repetir acción si no cambia
                        auxdef.valorBusqueda = valorBusqueda;
                        page.defaults = JSON.stringify(auxdef);
                        //Se recupera el valor por defecto del tipo de unidad de artículo
                        let tipoUnidad = flexygo.pda.articulo.TipoUnidad(datos.IdArticulo, pbLote.val() ? pbLote.val() : "");
                        tipoUnidad.then(function (tipo) {
                            //Tipos de Unidades del artículo para conversiones
                            pbComboUnidades[0].additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                            pbComboUnidades[0].refresh();
                            pbComboUnidades[0].querySelector("input").disabled = false;
                            if (tipo) {
                                pbComboUnidades.val(tipo);
                                pbUnidadStock.val(tipo);
                                pbCantidadStock.val(null);
                            }
                        });
                        tipoUnidad.catch(function (error) {
                            if (error && error != "") {
                                flexygo.msg.warning(error);
                                return;
                            }
                        });
                        //Focos
                        if (pbLote.attr("style") != 'display: none;' && !pbLote.val()) {
                            pbLote[0].querySelector("input").focus();
                        }
                        else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                            pbComboP1[0].querySelector("input").focus();
                        }
                        else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                            pbComboP2[0].querySelector("input").focus();
                        }
                        else {
                            pbCantidad[0].querySelector("input").focus();
                        }
                        $(".contStockUbicacion").addClass("hidden");
                    });
                    articulo.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                            return;
                        }
                    });
                    flexygo.pda.removeLock();
                }
            };
        })(recepcion = pda.recepcion || (pda.recepcion = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=recepcion.js.map